//+------------------------------------------------------------------+
//|                                               testIndiBuffer.mqh |
//|                             Copyright 2010, Loong@forum.mql4.com |
//|                             http://login.mql5.com/en/users/Loong |
//+------------------------------------------------------------------+
#property copyright "2010, Loong@forum.mql4.com"
#property link      "http://login.mql5.com/en/users/Loong"
#include <Indicators\Trend.mqh>
#include <Indicators\Oscilators.mqh>
#include <Indicators\Volumes.mqh>
#include <Indicators\BillWilliams.mqh>
#include <Indicators\Indicators.mqh>

#define iNumLines 2

MqlParam cIndiParamMACD[4]      = { { TYPE_INT,12, 0.0, ""}, 
                                    { TYPE_INT,26, 0.0, ""},
                                    { TYPE_INT, 9, 0.0, ""}, 
                                    { TYPE_INT, PRICE_CLOSE, 0.0, ""} };

// CLoongIndiBuffer << CIndicatorBuffer << CArrayDouble << CArray << CObject
// need a public buffer                     protected
// to use in                                 m_data[]
// CLoongIndiSelect::GetData
class CLoongIndiBuffer : public CIndicatorBuffer
  {
protected:
   //CObject* ReturnPointer(double& buffer[]) {return (CObject*)buffer;}
public:
   double m_buffer[]; //need a public buffer to use in CLoongIndiSelect::GetData
   //It can run. But I want to use the m_data[] that inherit from CArrayDouble
   //How to publicize the m_data[] in CArrayDouble?
   //I have tried these code, they are error.
   //double* GetBuffer() {return m_data;}
   //double[] GetBuffer() {return m_data;}
   //CObject* GetBuffer() {ReturnPointer(m_data);}
   //CObject* GetBuffer() {return (CObject*)(m_data[]);}

   bool SetIndexBuffer(int index, ENUM_INDEXBUFFER_TYPE data_type=INDICATOR_DATA)
   {return ::SetIndexBuffer(index, m_buffer, data_type);}
   //{return ::SetIndexBuffer(index, m_data, data_type);}
  };

class CLoongIndiSelect : public CIndicator
  {
protected:
   bool Initialize(string symbol,ENUM_TIMEFRAMES period,ENUM_INDICATOR iIndiType);
   bool CreateBuffers(string symbol,ENUM_TIMEFRAMES period,int buffers);
public:
   bool Create(string symbol,ENUM_TIMEFRAMES period,ENUM_INDICATOR type,int num_params,MqlParam &params[]);
   //bool SetIndexBuffer(int index, ENUM_INDEXBUFFER_TYPE data_type=INDICATOR_DATA)
   //{return ::SetIndexBuffer(index, indBuffer[index].m_buffer, data_type);}
   int  GetData(int count)
   {
      CLoongIndiBuffer *pIndiBuffer;
      for(int i=0; i<iNumLines; i++)
      {
         pIndiBuffer = At(i);
         if (false==GetData(0, count, i, pIndiBuffer.m_buffer))return(false); 
         //if (false==GetData(0, count, i, pIndiBuffer.m_data))return(false);
         // I want to use m_data
      }
      return(true);
   }
  };

bool CLoongIndiSelect::CreateBuffers(string symbol,ENUM_TIMEFRAMES period,int buffers)
  {
   bool result=true;
   CLoongIndiBuffer *buffer;
//--- checking
   if(m_handle==-1)      return(false);
   if(buffers==0)        return(false);
   if(!Reserve(buffers)) return(false);
//---
   for(int i=0;i<buffers;i++)
   {
      buffer = new CLoongIndiBuffer;
      result&=Add(buffer);
      if(!result) return(false);
      buffer.SetIndexBuffer(i);
   }
//---
   if(result)
     {
      if(symbol==NULL) m_symbol=ChartSymbol();
      else             m_symbol=symbol;
      if(period==0)    m_period=ChartPeriod();
      else             m_period=period;
      m_num_buffers=buffers;
     }
//---
   return(result);
  }
bool CLoongIndiSelect::Initialize(string symbol,ENUM_TIMEFRAMES period, ENUM_INDICATOR iIndiType)
  {
   bool result;
//--- formation status string
   m_name = "CLoongIndiSelect";
   //m_status="("+symbol+","+PeriodStr(period)+","+IntegerToString(ma_period)+") H="+IntegerToString(m_handle);
//--- tuning
   result = CreateBuffers(symbol,period,iNumLines);
//---
   return(result);
  }
bool CLoongIndiSelect::Create(string symbol, ENUM_TIMEFRAMES period, ENUM_INDICATOR type,int num_params,MqlParam &params[])
  {
   m_handle=IndicatorCreate(symbol,period,type,num_params,params);
//---
   if(m_handle!=-1)
     {
      //--- idicator creating successful
      if(!Initialize(symbol,period,type))
        {
         //--- initialization failed
         IndicatorRelease(m_handle);
         m_handle=-1;
         return(false);
        }
      return(true);
     }
//---
   return(false);
  }

